/******************************************************************************
	IWiprintf֐
******************************************************************************/


#include <stdarg.h>
#include "cq_printf.h"
#include "cpu_uart.h"
#include "integer.h"			//mu0309
//#include "ff.h"

/* printf֐ */
int cq_printf(char *format, ...)
{
	va_list argptr;
	int i;
	char buffer[100];
	va_start(argptr, format);
	i=_cq_vsnprintf(buffer, 100, format, argptr);
	va_end(argptr);

	/* UART\ */
	CPU_UartPutsL(buffer, i);

	return i;
}

/* printf֐ */
//int xprintf(char *format, ...)
//{
//	va_list argptr;
//	int i;
//	char buffer[100];
//	va_start(argptr, format);
//	i=_cq_vsnprintf(buffer, 100, format, argptr);
//	va_end(argptr);
//
//	/* UART\ */
//	CPU_UartPutsL(buffer, i);
//
//	return i;
//}

/* sprintf֐ */
int cq_sprintf(char *buffer, char *format, ...)
{
	va_list argptr;
	int i;
	va_start(argptr, format);
	i=cq_vsprintf(buffer, format, argptr);
	va_end(argptr);
	return i;
}

/* vsprintf֐ */
int cq_vsprintf(char *buffer, char *format, va_list argptr)
{
	return _cq_vsnprintf(buffer, 32767, format, argptr); /* 32767Ă͓̂Kɑ傫ꂽ */
}



/* printf͕ */

#define FC_MINUS (1)
#define FC_PLUS  (2)
#define FC_ZERO  (4)
#define FC_BLANK (8)
#define FC_SHARP (16)

/* ǂ */
int isdigit(char c)
{
  return ((c>='0')&&(c<='9'));
}

int strlen(char *s)
{
  int l;
  l = 0;
  while(*s++) l++;
  return l;
}

/* ӂꂽmȂ */
int _atoi_ptr(char **ptr)
{
  long l;
  int minus;
  char *p;
  p = *ptr;
  
  l = 0L;
  minus = 0;
  if(*p == '-') {
    minus = 1;
    p++;
  }
  
  while(isdigit(*p)){
    l *= 10;
    l += (*p-'0');
    p++;
  }
  if(minus) l = -l;
  *ptr = p; /* ߂ */
  /* printf("debug: %ld, %s\n", l, p); */
  return (int)l;
}

/* l當ɕϊ(t) */
int ntorstru(char *buf, unsigned long num, int base)
{
  unsigned long l, m;
  char *b0;
  char *cvt  = "0123456789abcdef";
  char *cvt1 = "0123456789ABCDEF";
  
  b0 = buf; /* ۑ */
  
  if(base<0) {
    cvt= cvt1;
    base = -base;
  }
  
  l = num;
  m = 0;
  
  if(l==0) *buf++ = '0';
  while(l) {
    m = l % base;
    l /= base;
    *buf++ = cvt[(int)m];
  }
  *buf = '\0';
  return buf-b0;
}


int _cq_vsnprintf(char *buffer, unsigned long count, char *format, va_list argptr)
/*
  buffer
    o͂̊i[ʒu
  count
    ލő啶
  format
    ̎w
  argptr
    Xgւ̃|C^
*/
{
  char *ptr, *eob;
  unsigned flags;       /* format control : flag characters */
  int ef;
  char *pf;
  int width;
  int precision;
  int longf;
  int len, len2;
  char *s;
  int i;
  char numbuf[30]; /* longōŒłǂꂭ炢H */
  int symbol, minus;
  long v;
  unsigned long uv;
  
  ptr = buffer;         /* current output pointer */
  eob = (char *)(ptr + count -1); /* end of buffer */
  
  pf = format;
  while(*pf){
    if(ptr >= eob) break; /* obt@͂ݏoc */
    
    if(*pf != '%') {
      *ptr++ = *pf++;  /* %ȂƂ͂̂܂܏o */
      continue;
    }
    
    pf++; /* skip '%' */
    
    /* correct flags */
    flags = 0;
    ef = 0;
    while(!ef){
      switch(*pf){
        case '-': 
          flags |= FC_MINUS;
          break;
        case '+': 
          flags |= FC_PLUS;
          break;
        case '0': 
          flags |= FC_ZERO;
          break;
        case ' ': 
          flags |= FC_BLANK;
          break;
/*        case '#': 
          flags |= FC_SHARP;
          break;
*/
        default:
          ef = 1;
          break;
      }
      if(!ef) pf++;
    }
    
    /* width */
    width = -1; /* none */
    if(isdigit(*pf)) width = _atoi_ptr(&pf);
    
    /* printf("debug: %s\n", pf); */
    
    precision = -1; /* none */
    if(*pf == '.') {
      pf++;
      precision = _atoi_ptr(&pf);
    }
    
    /* size flag */
    longf = 0;
    if(*pf == 'l') {
      pf++;
      longf = 1;
    }
    
    /* output */
    switch(*pf++) {
      case '%':
        if(ptr < eob) *ptr++ = '%';
        continue;
        /* break; */
      
      case 'c': /* w͖cĂ */
        if(ptr < eob) *ptr++ = (char)va_arg(argptr, int);
        continue;
        /* break; */
      
      case 's':
        /* printf("debug: s\n"); */
        s = va_arg(argptr, char *);
        len = strlen(s);
        /* width.precision ɂ镝 */
        if((precision != -1)&&(len > precision)) len = precision;
        if(width == -1) width = len;
        if(width < len) width = len; /* So͂ */
        
        if(!(flags & FC_MINUS)) { /* El߂̏ꍇ */
          for(i = 0; i < width - len; i++) {
            if(ptr < eob) *ptr++ = ' ';
          }
        }
        for(i = 0; i < len; i++) *ptr++ = *s++; /* 񕔕o */
        if((flags & FC_MINUS)) { /* l߂̏ꍇ */
          for(i = 0; i < width - len; i++) {
            if(ptr < eob) *ptr++ = ' ';
          }
        }
        continue;
        /*break;*/
      
      
      case 'd':
      case 'i':
        if(longf) {
          v = (long)va_arg(argptr, long);
        } else {
          v = (int)va_arg(argptr, int);
        }
        minus = (v < 0)?1:0;
        if(minus) v = -v;
        len = ntorstru(numbuf, v, 10);
        break;
      
      case 'u':
        if(longf) {
          uv = (unsigned long)va_arg(argptr, unsigned long);
        } else {
          uv = (unsigned int)va_arg(argptr, unsigned int);
        }
        len = ntorstru(numbuf, uv, 10);
        minus = 0;
        break;
      
      case 'o':
        if(longf) {
          uv = (unsigned long)va_arg(argptr, unsigned long);
        } else {
          uv = (unsigned int)va_arg(argptr, unsigned int);
        }
        len = ntorstru(numbuf, uv, 8);
        minus = 0;
        break;
      
      case 'x':
        if(longf) {
          uv = (unsigned long)va_arg(argptr, unsigned long);
        } else {
          uv = (unsigned int)va_arg(argptr, unsigned int);
        }
        len = ntorstru(numbuf, uv, 16);
        minus = 0;
        break;
      
      case 'X':
        if(longf) {
          uv = (unsigned long)va_arg(argptr, unsigned long);
        } else {
          uv = (unsigned int)va_arg(argptr, unsigned int);
        }
        len = ntorstru(numbuf, uv, -16); /* base<0a-f啶*/
        minus = 0;
        break;
      
      default:
        /* tOƉ߂ꂽ͖̂߂Ȃc */
        if(ptr < eob) *ptr++ = '%';
        if(ptr < eob) *ptr++ = *(pf-1);
        continue;
        /*break;*/
    }
    
    /* ȉ͐l̂ */
    
    /* i = va_arg(argptr, int); */
    /* len = ntorstr(numbuf, i, 10); */
    
    len2 = len; /* ܂߂o͂ɕKvȒ */
    symbol = 0; /*  */
    if(minus) {
      symbol = '-';
    } else {
      if(flags & FC_BLANK) symbol = ' ';
      if(flags & FC_PLUS)  symbol = '+'; /* ' '㏑ */
    }
    if(symbol) len2++; 
    
    if(width < precision) width = precision; /* width.precision ʂĂȂcł̂H */
    if(width < len2) width = len2;           /* ŒKvȕɊg(wȂꍇ܂) */
    
    if(!(flags & FC_MINUS)) { /* 񂹂łȂꍇ */
      if(flags & FC_ZERO) { /* ZERO-FILL */
        if(symbol) {
          if(ptr < eob) *ptr++ = symbol;              /* Ăc */
        }
        for(i=0;i<width-len2;i++) {
          if(ptr < eob) *ptr++ = '0';  /* Ԃ0Ŗ߂ */
        }
      } else {                 /* 񂹂̏ꍇ */
        for(i=0;i<width-len2;i++) {
          if(ptr < eob) *ptr++ = ' ';  /* Ԃ󔒂Ŗ߂Ă */
        }
        if(symbol) {
          if(ptr < eob) *ptr++ = symbol;              /*  */
        }
      }
    } else {
      if(symbol) {
        if(ptr < eob) *ptr++ = symbol;                /* KvȂ畄o */
      }
    }
    for(i = len - 1; i >= 0; i--) {
      if(ptr < eob) *ptr++ = numbuf[i]; /* (t̕)o͂ */
    }
    if(flags & FC_MINUS) { /* 񂹂ŕw肪΋󔒂o͂ */
      for(i = 0; i < width - len2; i++) {
        if(ptr < eob) *ptr++ = ' ';
      }
    }
    
    /* continue; */
  } /* while(*pf) */
  *ptr = '\0';
  return (ptr - buffer); /* o͂ */
}

/******************************** add mu0309 **************************/
void xputc (char d)
{
	BYTE i;

	if (d == '\n') xputc('\r');
	CPU_UartPutch(d);
}

void xputs (const char* str)
{
	char d;


	while ((d = *str++) != 0)
		xputc(d);
}

char xatoi (char **str, long *res)
{
	DWORD val;
	BYTE c, radix, s = 0;


	while ((c = **str) == ' ') (*str)++;
	if (c == '-') {
		s = 1;
		c = *(++(*str));
	}
	if (c == '0') {
		c = *(++(*str));
		if (c <= ' ') {
			*res = 0; return 1;
		}
		if (c == 'x') {
			radix = 16;
			c = *(++(*str));
		} else {
			if (c == 'b') {
				radix = 2;
				c = *(++(*str));
			} else {
				if ((c >= '0')&&(c <= '9'))
					radix = 8;
				else
					return 0;
			}
		}
	} else {
		if ((c < '1')||(c > '9'))
			return 0;
		radix = 10;
	}
	val = 0;
	while (c > ' ') {
		if (c >= 'a') c -= 0x20;
		c -= '0';
		if (c >= 17) {
			c -= 7;
			if (c <= 9) return 0;
		}
		if (c >= radix) return 0;
		val = val * radix + c;
		c = *(++(*str));
	}
	if (s) val = -val;
	*res = val;
	return 1;
}

//static
void put_dump (BYTE *buff, DWORD ofs, BYTE cnt)
{
	BYTE n;


	cq_printf("%08lX ", ofs);			//xprintf   mu0411
	for(n = 0; n < cnt; n++)
		cq_printf(" %02X", buff[n]);	//xprintf
	xputc(' ');
	for(n = 0; n < cnt; n++) {
		if ((buff[n] < 0x20)||(buff[n] >= 0x7F))
			xputc('.');
		else
			xputc(buff[n]);
	}
	xputc('\n');
}

char xgetc ()
{

	BYTE d;

	d = CPU_UartGetch();

	return d;
}


void get_line (char *buff, int len)
{
	char c;
	BYTE idx = 0;


	for (;;) {
		c = xgetc();
		if (c == '\r') break;
		if ((c == '\b') && idx) {
			idx--; xputc(c);
		}
		if (((BYTE)c >= ' ') && (idx < len - 1)) {
				buff[idx++] = c; xputc(c);
		}
	}
	buff[idx] = 0;
	xputc('\n');
}


