/***********************************************************
  MMCJ[hhCo(SPI[h)wb_
  CQ Tech-I Vol. 35p
     Original Version Interface 2006.3  FJ
     TECH-I   Version Interface 2006.9  chv
 **********************************************************/

#ifndef _MMCDRV_
#define _MMCDRV_

#include "TYPEDEF.H"
#include "MMC_IO.H"

#define C_OFF   0x0000
#define R_OFF   0x2000
#define W_OFF   0x1000

/* R}hg[NX|X` */
#define CMD_PARAM_ERROR		0x40
#define ADDRESS_ERROR		0x20
#define ERASE_SEQ_ERROR		0x10
#define CMD_CRC_ERROR		0x08
#define COMUNC_ILLEG_COM	0x04
#define ERASE_RESET		0x02
#define CARD_IS_NOT_READY	0x01

/* f[^g[NX|X` */
#define CARD_IS_LOCKED		0x10
#define OUT_OF_RANGE		0x08
#define CARD_ECC_FAILED		0x04
#define CC_ERROR		0x02
#define OTHER_ERROR		0x01

#define DATA_NO_ERROR		0x05
#define DATA_CRC_ERROR		0x0B
#define DATA_WRITE_ERROR        0x0D

#define MMC_TIMEOUT_ERROR       (-1)
#define MMC_LBA_RANGE_ERROR     (-2)
#define MMC_INIT_ERROR          (-3)
#define MMC_CARD_DECTECT_ERROR  (-6)
#define MMC_WRITE_PROTECT_ERROR (-7)


/* MMC\PbgC^[tF[X */
#define MMC_DrverInit()	mmcio_SocketInit();

/* MMCJ[h */
int MMC_CardInit(void);

/* CSDWX^l̊l */
int MMC_GetCSD(UBYTE *);

/* CIDWX^l̊l */
int MMC_GetCID(UBYTE *);

/* MMCf[^ǂݏo */
int MMC_Read(ULONG, UBYTE *, const UWORD);

/* MMCf[^ */
int MMC_Write(ULONG, const UBYTE *, const UWORD);

/* MMCJ[hXe[^X擾 */
int MMC_GetStatus(void);

#endif
