/***************************************************************
	CPU UART VAR\[o̓hCo(SH-2 SCIp)
***************************************************************/
#include "iodefine.h"
//#include <machine.h>

/* CPU UARTo̓wb_ */
#include "cpu_uart.h"

/* SCI0 AhX` */
//#define pbSCSMR  ((volatile unsigned char *)(0xFFFF81A0))	//SMR_0	SCI0
//#define pbSCBRR  ((volatile unsigned char *)(0xFFFF81A1))	//BRR_0		
//#define pbSCSCR  ((volatile unsigned char *)(0xFFFF81A2))	//SCR_0
//#define pbSCTDR  ((volatile unsigned char *)(0xFFFF81A3))	//TDR_0
//#define pbSCSSR  ((volatile unsigned char *)(0xFFFF81A4))	//SSR_0
//#define pbSCRDR  ((volatile unsigned char *)(0xFFFF81A5))	//RDR_0
//#define pbSCSDCR ((volatile unsigned char *)(0xFFFF81A6))	//SDCR_0
/* SCI1 AhX` */
#define pbSCSMR  ((volatile unsigned char *)(0xFFFF81B0))	//SMR_1	SCI1
#define pbSCBRR  ((volatile unsigned char *)(0xFFFF81B1))	//BRR_1		
#define pbSCSCR  ((volatile unsigned char *)(0xFFFF81B2))	//SCR_1
#define pbSCTDR  ((volatile unsigned char *)(0xFFFF81B3))	//TDR_1
#define pbSCSSR  ((volatile unsigned char *)(0xFFFF81B4))	//SSR_1
#define pbSCRDR  ((volatile unsigned char *)(0xFFFF81B5))	//RDR_1
#define pbSCSDCR ((volatile unsigned char *)(0xFFFF81B6))	//SDCR_1

/* |[g AhX` */
#define pwPACRL2 ((volatile unsigned short *)(0xFFFF838E))	//PACRL2
#define pwPEDRL  ((volatile unsigned short *)(0xFFFF83B0))	//PEDRL
#define pwPEIORL ((volatile unsigned short *)(0xFFFF83B4))	//PEIORL
#define pwPECRL1 ((volatile unsigned short *)(0xFFFF83B8))	//PECRL1
#define pwPECRL2 ((volatile unsigned short *)(0xFFFF83BA))	//PECRL2

/* W[X^oC */
#define pwMSTCR1 ((volatile unsigned short *)(0xFFFF861C))	//MSTCR1


/* R\[(UART) */
void CPU_UartInitialize(void)
{
	int i;
	
//	*pwMSTCR1=(*pwMSTCR1 &0xFFFD);	//	&0xFFFE);	/* SCI0X^oC ->SCI1*/
	MST.CR1.BIT._SCI1=0;	// SCI_1L

//	*pwPACRL2=(*pwPACRL2 | 0x0140);	//	| 5);		/* SCI0L(TXD0/RXD0) ->SCI1 */
	PFC.PACRL2.BIT.PA4MD=1;
	
	*pbSCSCR=0x00;		/* TE=0,RE=0,CKE1=0 */
//	SCI1.SCR.BYTE=0;
	
	*pbSCSMR=0x00;		/* CHR=0,PE=0,STOP=0,CKS=00(P/1) */
//	SCI1.SMR.BYTE=0;
	
	*pbSCBRR=19;		/* 38400bpsݒ 	38;	19200bpsݒ*/
//	SCI1.BRR=19;
	
	for(i=0;i<0x80000;i++);	/* EFCg */
	
	*pbSCSCR=0x30;		/* TIE=0,RIE=0,TE=1,RE=1 */
//	SCI1.SCR.BYTE=0x30;
}

/* R\[1o */
/*
void CPU_UartPutch(char data)
{
	while(1){
		if (*pbSCSSR & 0x80) {			//Mobt@󂢂Ă邩
			*pbSCTDR=data;
			*pbSCSSR=(*pbSCSSR & 0x7C);
			break;
		}
	}
}
*/

void CPU_UartPutch(char data)
{
	while (SCI1.SSR.BIT.TDRE==0);
	SCI1.TDR=data;
	SCI1.SSR.BIT.TDRE=0;
}

/* R\[o(\n CR+LFo) */
void CPU_UartPuts(char *buffer)
{
	char data;
	while( (data=*(buffer++)) != 0){	/* null܂ŏo */
		if (data == 0x0a) {
			CPU_UartPutch(0x0d);	/* CRo */
			CPU_UartPutch(0x0a);	/* LFo */
		} else {
			CPU_UartPutch(data);	/* 1o */
		}
	}
}

/* R\[o(񒷂wt/\n CR+LFo) */
void CPU_UartPutsL(char *buffer, int len)
{
	int i;
	char data;
	for(i=0;i<len;i++){
		data=*(buffer++);
		if (data == 0x0a) {
			CPU_UartPutch(0x0d);	/* CRo */
			CPU_UartPutch(0x0a);	/* LFo */
		} else {
			CPU_UartPutch(data);	/* 1o */
		}
	}
}

/* R\[̓obt@`FbN */
int CPU_UartRecvCheck(void)
{
	if (*pbSCSSR & 0x40) {	/* f[^M */
		return 1;	/* Mf[^ */
	} else {
		return 0;	/* Mf[^Ȃ */
	}
}

/* R\[1(GR[obNȂ) */
char CPU_UartGetch(void)
{
	char data;
	while(1){
		if (*pbSCSSR & 0x40) {	/* f[^M */
			data=*pbSCRDR;
			*pbSCSSR=(*pbSCSSR & 0xBC);
			break;
		}
	}
	return data;
}

/* R\[(CRR[h܂/ő255/GR[obN) */
int CPU_UartGets(char *buffer)
{
	char data;
	int i;
	i=0;
	while(1){
		data=CPU_UartGetch();		/* 1 */
		*buffer=data;
		CPU_UartPutch(data);		/* 1o(GR[obN) */
		buffer++;
		i++;
		if (i>255) break;		/* ő啶ɒB */
		if (data==0x0d) break;	/* CRR[h܂ŎM */
	}
	*buffer=(unsigned char)0;	/* nullR[h */
	return i;					/* ͕ */
}

void prstr(char *x){
	char d;
	while(*x != 0) {
		d=*x++;
		if(d=='\n') {CPU_UartPutch(0x0d); CPU_UartPutch(0x0a);}
		else CPU_UartPutch(d);
	}
}