/***********************************************************
	MMCJ[hhCo I/OhCo (SH-2 SCIp)
***********************************************************/

#include "TYPEDEF.H"
#include "SH2.H"
#include "MMC_IO.H"

#include "cq_printf.h"


/* SH-2 MMC\Pbg|[g` */
#define	MMC_OutPort	pwPEDRL		/* o̓|[gAhX */
#define	MMC_InPort	pwPEDRL		/* ̓|[gAhX */
#define	CS_BIT		0x0200		/* rbgʒu PE9  */
#define	DIN_BIT		0x0400		/* rbgʒu PE10 */
#define	CLK_BIT		0x0100		/* rbgʒu PE8  */
#define	DOUT_BIT	0x0080		/* rbgʒu PE7  */

unsigned short	PortReg;		/* |[gWX^lێ */

#define	MMC_StatPort pwPEDRL	/* ̓|[gAhX */
#define	CD_BIT		0x0040		/* rbgʒu PE6 */
#define	WP_BIT		0x0020		/* rbgʒu PE5 */


/* rbgMEFCg */
void bit_wait(void)
{
	UWORD c;
	c=*MMC_InPort;	/* _~[ǂݏo */
}

/* MMC CS */
void mmcio_CsCtrl(int enable)
{
	if (enable) {
		PortReg = PortReg & ~CS_BIT;	/* CSCl[u */
	} else {
		mmcio_Send1byte(0xFF);			/* _~[NbNM */
		PortReg = PortReg | CS_BIT;		/* CSfBZ[u */
	}
	*MMC_OutPort = PortReg;
}

/* MMC1oCgM */
void mmcio_Send1byte(UBYTE data)
{
	while((*pbSCSSR2&0x80)==0);	/* Mobt@󂭂܂ő҂ */
	*pbSCTDR2=data;				/* Mf[^ */
	*pbSCSSR2=0x7C;				/* MJn(TDRENA) */
	return;
}

/* MMC1oCgM */
UBYTE mmcio_Recv1byte(void)
{
	UBYTE c,data;

	/* M҂ */
	while(1){
		c=*pbSCSSR2;
		if (c&0x20) {		/* I[o[G[ */
			*pbSCSSR2=0xDC;	/* I[o[G[ NA */
		}
		if (c&0x04) break;	/* M */
	}
	/* MJn */
	*pbSCSCR2=0x00;			/* ~ */
	*pbSCSCR2=0x10;			/* MCl[u */
	while(1){				/* f[^M҂ */
		if (*pbSCSSR2 & 0x40) {	/* Mobt@ɎMf[^ */
			*pbSCSCR2=0x00;	/* ~ */
			data=*pbSCRDR2;	/* Mf[^ǂݏo */
			*pbSCSSR2=0x0;	/* M(RDRFNA) */
			break;
		}
	}
	/* MI */
	*pbSCSCR2=0x20;			/* MCl[u */
	return data;
}

/* J[h}Ԍo */
int mmcio_CardDetectCheck(void)
{
	if (*MMC_StatPort & CD_BIT) {	/* J[h} */
		return 0;	/* J[hȂ */
	} else {
		return 1;	/* J[h} */
	}
	/* J[h}ԂołȂn[hEFȀꍇ́A펞 return 1 Ƃ */
}

/* J[hCgveNgXCb`Ԍo */
int mmcio_WritePortectCheck(void)
{
	if (mmcio_CardDetectCheck()) {	/* J[h}Ԏ̂݃`FbN */
		if (*MMC_StatPort & WP_BIT) {	/* 񃉃CgveNg */
			return 1;	/* ݕs */
		} else {
			return 0;	/* ݉ */
		}
	} else {
		return 1;		/* ݕs */
	}
	/* J[h}ԂołȂn[hEFȀꍇ́A펞 return 0 Ƃ */
}

/* MMC\PbgC^[tF[X */
int mmcio_SocketInit(void)
{
	UWORD c;
	int i;

	/* SCI */
	*pwMSTCR1=(*pwMSTCR1 & 0xFFFB);	/* SCI2X^oC */
	*pbSCSDCR2=0xFA;	/* MSBt@[Xg */
	*pbSCSCR2=0x00;		/* M/MfBZ[u */
	*pbSCSMR2=0x80;		/* NbN[h/ӃNbNn=0 */
	*pbSCBRR2=128;		/* 3MHz */
	for(i=0;i<0x8000;i++){}	/* EFCg */
	c=*pbSCSSR2;		/* Xe[^Xǂ */
	*pbSCSSR2=0;		/* Xe[^XNA */
	*pbSCSCR2=0x20;		/* MCl[u 荞ݖgp SCKNbNo */

	/* GPIO */
	*pwPEDRL =0x8200;	//0x0200;	/* PE9,15="H" */
	*pwPEIORL=0x8300;	//0x0300;	/* PE9/8=o PE6/5= PE15=out, PE12=in*/
	*pwPECRL1=0x0022;	/* PE10=TXD2 PE9=IO PE8=SCK2 */
	*pwPECRL2=0x8000;	/* PE7 =RXD2 PE6=IO PE5=IO */
	PortReg = *MMC_OutPort;
	PortReg = PortReg | CS_BIT;
	*MMC_OutPort = PortReg;
	return 0;
}
